import numpy as np

def gradient_descent(start, function, gradient, learn_rate, max_iter, tol=0.001):
  x = start
  for it in range(max_iter):
    diff = learn_rate*gradient(x)
    if np.abs(diff) < tol:
      break
    print("iteration =", it, "\t\tx =", "{:.5f}".format(x), "\t\tf(x) =", "{:.3f}".format(function(x)))
    x = x - diff

# a simple function f(x) = x^2 - 4x + 1
def func(x):
  return x**2-4*x+1

# the gradient of the function
def gradient_func(x):
  return 2*x - 4


gradient_descent(9, func, gradient_func, 0.1, 100)
